/*Copyright 2003 The Board of Trustees of The Leland Stanford Junior University.
  All Rights Reserved.

  Communication to Jessica Ebert (jessicas@stanford.edu)
*/

#define _LOCKDIR_ "/usr/local/bin"
#define _SCRIPTDIR_ "/var/www/cgi-bin/FoldMiner"
#define _DSSPPROGRAM_ "/usr/local/bin/dsspcmbi -na"

#define SHOWOUTPUT 1
#define DRAWJOINTS 1


#define X 0
#define Y 1
#define Z 2
#define W 3
#define PI 3.1415926535897
#define SIZEX 50.0
#define SIZEY 50.0
#define EYEX 0.0
#define EYEY 0.0
#define EYEZ -50.0
#define MAXITERATIONS 10 /*used to be 10*/
#define MAXDIFFERENCE 0.1   /*used to be 0.1*/
#define MAXLENGTH 5000
#define WINDOW 7
#define MAXSS 500 
#define MAXPTRS 20
#define SSE_REALIGNMENT_RMSD_CUTOFF 2
#define NULLVALUE -10000  

typedef float Matrix[4][4];
typedef float Matrix3[3][3];
typedef float Vector[3];
typedef float Quaternion[4];

#ifndef DISPLAYON
typedef float GLfloat;
#endif

typedef struct obj { 
  float points[MAXLENGTH][3]; 
  float cbpoints[MAXLENGTH][3]; /*beta carbons*/
  float pairDists[MAXLENGTH]; 
  int pairNums[MAXLENGTH]; 
  int aaNums[MAXLENGTH];
  char chains[MAXLENGTH];
  char insertionCodes[MAXLENGTH];
  int numPts; 
  int modelNumber; 
  int ssArrayLength; 
  int *ssArray;
  int *ssNumbers; /*map residue numbers to sequential sse numbers*/
  char *sstype;  /*'H','S',or 'U'*/
  float color[3]; 
  float center[3]; 
  char *objSeq; 
  int *aaNumbers;
  float objMat[16]; 
  int **ss_alignment; /*indexed by query SSE number; value is
		      *aligned target SSE number*/
  int *num_aligned; /*num of SSEs aligned to each SSE of this object*/
  float *ss_dpscores; /*dp score for each sse, if aligned*/
  int num_SSEs_aligned; /*number of aligned SSEs*/
  int num_repeated_SSE_alignments; /*SSEs aligned more than once*/
  int num_helices;
  int num_strands;
  int *nextPairedResidue; /*-1 if not paired, otherwise contains the index of the next
			   *paired residue of the protein*/
  char header[100]; 
  char compound[100]; 

  int lock_positions[MAXLENGTH]; /*residues that will be aligned to another object's lock positions to produce an initial alignment*/
  int num_lock_positions; /*number of positions to lock*/


  float alignmentScore[MAXLENGTH];
  float gapScore[MAXLENGTH];

} OBJ; 


